uploaded to dev.alpinelinux.org due to size
Patch-Source: https://github.com/STJr/SRB2/compare/6ede8aa9dcd33f8f8e4dfdee502f874b63c28a33...639b58c6d718452ef343a0bc927d043bed9e40d6
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index b02d0f69cb..6ea63e9474 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -143,7 +143,7 @@ if("${CMAKE_COMPILER_IS_GNUCC}" AND "${CMAKE_SYSTEM_NAME}" MATCHES "Windows")
 	endif()
 endif()
 
-target_compile_features(SRB2SDL2 PRIVATE c_std_11 cxx_std_17)
+target_compile_features(SRB2SDL2 PRIVATE c_std_23 cxx_std_17)
 
 ### Configuration
 set(SRB2_CONFIG_DEV_BUILD OFF CACHE BOOL
diff --git a/src/d_think.h b/src/d_think.h
index 76c1bb5b8a..077f3e3b0b 100644
--- a/src/d_think.h
+++ b/src/d_think.h
@@ -28,18 +28,11 @@
 // To compile this as "ANSI C with classes" we will need to handle the various
 //  action functions cleanly.
 //
-typedef void (*actionf_v)();
 typedef void (*actionf_p1)(void *);
 
-typedef union
-{
-	actionf_v acv;
-	actionf_p1 acp1;
-} actionf_t;
-
 // Historically, "think_t" is yet another function pointer to a routine
 // to handle an actor.
-typedef actionf_t think_t;
+typedef actionf_p1 think_t;
 
 // Doubly linked list of actors.
 typedef struct thinker_s
diff --git a/src/deh_lua.c b/src/deh_lua.c
index 48f737a1ff..d01aa44a73 100644
--- a/src/deh_lua.c
+++ b/src/deh_lua.c
@@ -188,7 +188,7 @@ static inline int lib_freeslot(lua_State *L)
 // Arguments: mobj_t actor, int var1, int var2
 static int action_call(lua_State *L)
 {
-	actionf_t *action = *((actionf_t **)luaL_checkudata(L, 1, META_ACTION));
+	actionf_p1 *action = *((actionf_p1 **)luaL_checkudata(L, 1, META_ACTION));
 	mobj_t *actor = *((mobj_t **)luaL_checkudata(L, 2, META_MOBJ));
 
 	var1 = (INT32)luaL_optinteger(L, 3, 0);
@@ -199,7 +199,7 @@ static int action_call(lua_State *L)
 		return LUA_ErrInvalid(L, "mobj_t");
 	}
 
-	action->acp1(actor);
+	(*action)(actor);
 	return 0;
 }
 
@@ -632,7 +632,7 @@ FUNCINLINE static ATTRINLINE int getEnum(lua_State *L, boolean mathlib, const ch
 		{
 			if (fasticmp(word, actionpointers[i].name))
 			{
-				// We push the actionf_t* itself as userdata!
+				// We push the actionf_p1* itself as userdata!
 				LUA_PushUserdata(L, &actionpointers[i].action, META_ACTION);
 				return 1;
 			}
@@ -770,7 +770,7 @@ static int lib_getActionName(lua_State *L)
 {
 	if (lua_isuserdata(L, 1)) // arg 1 is built-in action, expect action userdata
 	{
-		actionf_t *action = *((actionf_t **)luaL_checkudata(L, 1, META_ACTION));
+		actionf_p1 *action = *((actionf_p1 **)luaL_checkudata(L, 1, META_ACTION));
 		const char *name = NULL;
 		if (!action)
 			return luaL_error(L, "not a valid action?");
@@ -840,11 +840,11 @@ int LUA_SOCLib(lua_State *L)
 
 const char *LUA_GetActionName(void *action)
 {
-	actionf_t *act = (actionf_t *)action;
+	actionf_p1 *act = (actionf_p1 *)action;
 	size_t z;
 	for (z = 0; actionpointers[z].name; z++)
 	{
-		if (actionpointers[z].action.acv == act->acv)
+		if (actionpointers[z].action == *act)
 			return actionpointers[z].name;
 	}
 	return NULL;
@@ -859,8 +859,6 @@ void LUA_SetActionByName(void *state, const char *actiontocompare)
 		if (fasticmp(actiontocompare, actionpointers[z].name))
 		{
 			st->action = actionpointers[z].action;
-			st->action.acv = actionpointers[z].action.acv; // assign
-			st->action.acp1 = actionpointers[z].action.acp1;
 			return;
 		}
 	}
diff --git a/src/deh_soc.c b/src/deh_soc.c
index 343beb3012..82e806c115 100644
--- a/src/deh_soc.c
+++ b/src/deh_soc.c
@@ -2844,7 +2844,7 @@ void readframe(MYFILE *f, INT32 num)
 
 				for (z = 0; actionpointers[z].name; z++)
 				{
-					if (actionpointers[z].action.acv == states[num].action.acv)
+					if (actionpointers[z].action == states[num].action)
 						break;
 				}
 
@@ -2856,8 +2856,6 @@ void readframe(MYFILE *f, INT32 num)
 						if (fastcmp(actiontocompare, actionpointers[z].name))
 						{
 							states[num].action = actionpointers[z].action;
-							states[num].action.acv = actionpointers[z].action.acv; // assign
-							states[num].action.acp1 = actionpointers[z].action.acp1;
 							found = true;
 							break;
 						}
diff --git a/src/deh_tables.c b/src/deh_tables.c
index d714632535..46dc61034d 100644
--- a/src/deh_tables.c
+++ b/src/deh_tables.c
@@ -73,278 +73,278 @@ struct flickytypes_s FLICKYTYPES[] = {
 // DO NOT FORGET TO SYNC THIS LIST WITH THE ACTIONNUM ENUM IN INFO.H
 actionpointer_t actionpointers[] =
 {
-	{{A_Explode},                "A_EXPLODE"},
-	{{A_Pain},                   "A_PAIN"},
-	{{A_Fall},                   "A_FALL"},
-	{{A_MonitorPop},             "A_MONITORPOP"},
-	{{A_GoldMonitorPop},         "A_GOLDMONITORPOP"},
-	{{A_GoldMonitorRestore},     "A_GOLDMONITORRESTORE"},
-	{{A_GoldMonitorSparkle},     "A_GOLDMONITORSPARKLE"},
-	{{A_Look},                   "A_LOOK"},
-	{{A_Chase},                  "A_CHASE"},
-	{{A_FaceStabChase},          "A_FACESTABCHASE"},
-	{{A_FaceStabRev},            "A_FACESTABREV"},
-	{{A_FaceStabHurl},           "A_FACESTABHURL"},
-	{{A_FaceStabMiss},           "A_FACESTABMISS"},
-	{{A_StatueBurst},            "A_STATUEBURST"},
-	{{A_FaceTarget},             "A_FACETARGET"},
-	{{A_FaceTracer},             "A_FACETRACER"},
-	{{A_Scream},                 "A_SCREAM"},
-	{{A_BossDeath},              "A_BOSSDEATH"},
-	{{A_SetShadowScale},         "A_SETSHADOWSCALE"},
-	{{A_ShadowScream},           "A_SHADOWSCREAM"},
-	{{A_CustomPower},            "A_CUSTOMPOWER"},
-	{{A_GiveWeapon},             "A_GIVEWEAPON"},
-	{{A_RingBox},                "A_RINGBOX"},
-	{{A_Invincibility},          "A_INVINCIBILITY"},
-	{{A_SuperSneakers},          "A_SUPERSNEAKERS"},
-	{{A_BunnyHop},               "A_BUNNYHOP"},
-	{{A_BubbleSpawn},            "A_BUBBLESPAWN"},
-	{{A_FanBubbleSpawn},         "A_FANBUBBLESPAWN"},
-	{{A_BubbleRise},             "A_BUBBLERISE"},
-	{{A_BubbleCheck},            "A_BUBBLECHECK"},
-	{{A_AwardScore},             "A_AWARDSCORE"},
-	{{A_ExtraLife},              "A_EXTRALIFE"},
-	{{A_GiveShield},             "A_GIVESHIELD"},
-	{{A_GravityBox},             "A_GRAVITYBOX"},
-	{{A_ScoreRise},              "A_SCORERISE"},
-	{{A_AttractChase},           "A_ATTRACTCHASE"},
-	{{A_DropMine},               "A_DROPMINE"},
-	{{A_FishJump},               "A_FISHJUMP"},
-	{{A_ThrownRing},             "A_THROWNRING"},
-	{{A_SetSolidSteam},          "A_SETSOLIDSTEAM"},
-	{{A_UnsetSolidSteam},        "A_UNSETSOLIDSTEAM"},
-	{{A_SignSpin},               "A_SIGNSPIN"},
-	{{A_SignPlayer},             "A_SIGNPLAYER"},
-	{{A_OverlayThink},           "A_OVERLAYTHINK"},
-	{{A_JetChase},               "A_JETCHASE"},
-	{{A_JetbThink},              "A_JETBTHINK"},
-	{{A_JetgThink},              "A_JETGTHINK"},
-	{{A_JetgShoot},              "A_JETGSHOOT"},
-	{{A_ShootBullet},            "A_SHOOTBULLET"},
-	{{A_MinusDigging},           "A_MINUSDIGGING"},
-	{{A_MinusPopup},             "A_MINUSPOPUP"},
-	{{A_MinusCheck},             "A_MINUSCHECK"},
-	{{A_ChickenCheck},           "A_CHICKENCHECK"},
-	{{A_MouseThink},             "A_MOUSETHINK"},
-	{{A_DetonChase},             "A_DETONCHASE"},
-	{{A_CapeChase},              "A_CAPECHASE"},
-	{{A_RotateSpikeBall},        "A_ROTATESPIKEBALL"},
-	{{A_SlingAppear},            "A_SLINGAPPEAR"},
-	{{A_UnidusBall},             "A_UNIDUSBALL"},
-	{{A_RockSpawn},              "A_ROCKSPAWN"},
-	{{A_SetFuse},                "A_SETFUSE"},
-	{{A_CrawlaCommanderThink},   "A_CRAWLACOMMANDERTHINK"},
-	{{A_SmokeTrailer},           "A_SMOKETRAILER"},
-	{{A_RingExplode},            "A_RINGEXPLODE"},
-	{{A_OldRingExplode},         "A_OLDRINGEXPLODE"},
-	{{A_MixUp},                  "A_MIXUP"},
-	{{A_RecyclePowers},          "A_RECYCLEPOWERS"},
-	{{A_Boss1Chase},             "A_BOSS1CHASE"},
-	{{A_FocusTarget},            "A_FOCUSTARGET"},
-	{{A_Boss2Chase},             "A_BOSS2CHASE"},
-	{{A_Boss2Pogo},              "A_BOSS2POGO"},
-	{{A_BossZoom},               "A_BOSSZOOM"},
-	{{A_BossScream},             "A_BOSSSCREAM"},
-	{{A_Boss2TakeDamage},        "A_BOSS2TAKEDAMAGE"},
-	{{A_Boss7Chase},             "A_BOSS7CHASE"},
-	{{A_GoopSplat},              "A_GOOPSPLAT"},
-	{{A_Boss2PogoSFX},           "A_BOSS2POGOSFX"},
-	{{A_Boss2PogoTarget},        "A_BOSS2POGOTARGET"},
-	{{A_BossJetFume},            "A_BOSSJETFUME"},
-	{{A_EggmanBox},              "A_EGGMANBOX"},
-	{{A_TurretFire},             "A_TURRETFIRE"},
-	{{A_SuperTurretFire},        "A_SUPERTURRETFIRE"},
-	{{A_TurretStop},             "A_TURRETSTOP"},
-	{{A_JetJawRoam},             "A_JETJAWROAM"},
-	{{A_JetJawChomp},            "A_JETJAWCHOMP"},
-	{{A_PointyThink},            "A_POINTYTHINK"},
-	{{A_CheckBuddy},             "A_CHECKBUDDY"},
-	{{A_HoodFire},               "A_HOODFIRE"},
-	{{A_HoodThink},              "A_HOODTHINK"},
-	{{A_HoodFall},               "A_HOODFALL"},
-	{{A_ArrowBonks},             "A_ARROWBONKS"},
-	{{A_SnailerThink},           "A_SNAILERTHINK"},
-	{{A_SharpChase},             "A_SHARPCHASE"},
-	{{A_SharpSpin},              "A_SHARPSPIN"},
-	{{A_SharpDecel},             "A_SHARPDECEL"},
-	{{A_CrushstaceanWalk},       "A_CRUSHSTACEANWALK"},
-	{{A_CrushstaceanPunch},      "A_CRUSHSTACEANPUNCH"},
-	{{A_CrushclawAim},           "A_CRUSHCLAWAIM"},
-	{{A_CrushclawLaunch},        "A_CRUSHCLAWLAUNCH"},
-	{{A_VultureVtol},            "A_VULTUREVTOL"},
-	{{A_VultureCheck},           "A_VULTURECHECK"},
-	{{A_VultureHover},           "A_VULTUREHOVER"},
-	{{A_VultureBlast},           "A_VULTUREBLAST"},
-	{{A_VultureFly},             "A_VULTUREFLY"},
-	{{A_SkimChase},              "A_SKIMCHASE"},
-	{{A_1upThinker},             "A_1UPTHINKER"},
-	{{A_SkullAttack},            "A_SKULLATTACK"},
-	{{A_LobShot},                "A_LOBSHOT"},
-	{{A_FireShot},               "A_FIRESHOT"},
-	{{A_SuperFireShot},          "A_SUPERFIRESHOT"},
-	{{A_BossFireShot},           "A_BOSSFIRESHOT"},
-	{{A_Boss7FireMissiles},      "A_BOSS7FIREMISSILES"},
-	{{A_Boss1Laser},             "A_BOSS1LASER"},
-	{{A_Boss4Reverse},           "A_BOSS4REVERSE"},
-	{{A_Boss4SpeedUp},           "A_BOSS4SPEEDUP"},
-	{{A_Boss4Raise},             "A_BOSS4RAISE"},
-	{{A_SparkFollow},            "A_SPARKFOLLOW"},
-	{{A_BuzzFly},                "A_BUZZFLY"},
-	{{A_GuardChase},             "A_GUARDCHASE"},
-	{{A_EggShield},              "A_EGGSHIELD"},
-	{{A_SetReactionTime},        "A_SETREACTIONTIME"},
-	{{A_Boss1Spikeballs},        "A_BOSS1SPIKEBALLS"},
-	{{A_Boss3TakeDamage},        "A_BOSS3TAKEDAMAGE"},
-	{{A_Boss3Path},              "A_BOSS3PATH"},
-	{{A_Boss3ShockThink},        "A_BOSS3SHOCKTHINK"},
-	{{A_Shockwave},              "A_SHOCKWAVE"},
-	{{A_LinedefExecute},         "A_LINEDEFEXECUTE"},
-	{{A_LinedefExecuteFromArg},  "A_LINEDEFEXECUTEFROMARG"},
-	{{A_PlaySeeSound},           "A_PLAYSEESOUND"},
-	{{A_PlayAttackSound},        "A_PLAYATTACKSOUND"},
-	{{A_PlayActiveSound},        "A_PLAYACTIVESOUND"},
-	{{A_SpawnObjectAbsolute},    "A_SPAWNOBJECTABSOLUTE"},
-	{{A_SpawnObjectRelative},    "A_SPAWNOBJECTRELATIVE"},
-	{{A_ChangeAngleRelative},    "A_CHANGEANGLERELATIVE"},
-	{{A_ChangeAngleAbsolute},    "A_CHANGEANGLEABSOLUTE"},
-	{{A_RollAngle},              "A_ROLLANGLE"},
-	{{A_ChangeRollAngleRelative},"A_CHANGEROLLANGLERELATIVE"},
-	{{A_ChangeRollAngleAbsolute},"A_CHANGEROLLANGLEABSOLUTE"},
-	{{A_PlaySound},              "A_PLAYSOUND"},
-	{{A_FindTarget},             "A_FINDTARGET"},
-	{{A_FindTracer},             "A_FINDTRACER"},
-	{{A_SetTics},                "A_SETTICS"},
-	{{A_SetRandomTics},          "A_SETRANDOMTICS"},
-	{{A_ChangeColorRelative},    "A_CHANGECOLORRELATIVE"},
-	{{A_ChangeColorAbsolute},    "A_CHANGECOLORABSOLUTE"},
-	{{A_Dye},                    "A_DYE"},
-	{{A_SetTranslation},         "A_SETTRANSLATION"},
-	{{A_MoveRelative},           "A_MOVERELATIVE"},
-	{{A_MoveAbsolute},           "A_MOVEABSOLUTE"},
-	{{A_Thrust},                 "A_THRUST"},
-	{{A_ZThrust},                "A_ZTHRUST"},
-	{{A_SetTargetsTarget},       "A_SETTARGETSTARGET"},
-	{{A_SetObjectFlags},         "A_SETOBJECTFLAGS"},
-	{{A_SetObjectFlags2},        "A_SETOBJECTFLAGS2"},
-	{{A_RandomState},            "A_RANDOMSTATE"},
-	{{A_RandomStateRange},       "A_RANDOMSTATERANGE"},
-	{{A_StateRangeByAngle},      "A_STATERANGEBYANGLE"},
-	{{A_StateRangeByParameter},  "A_STATERANGEBYPARAMETER"},
-	{{A_DualAction},             "A_DUALACTION"},
-	{{A_RemoteAction},           "A_REMOTEACTION"},
-	{{A_ToggleFlameJet},         "A_TOGGLEFLAMEJET"},
-	{{A_OrbitNights},            "A_ORBITNIGHTS"},
-	{{A_GhostMe},                "A_GHOSTME"},
-	{{A_SetObjectState},         "A_SETOBJECTSTATE"},
-	{{A_SetObjectTypeState},     "A_SETOBJECTTYPESTATE"},
-	{{A_KnockBack},              "A_KNOCKBACK"},
-	{{A_PushAway},               "A_PUSHAWAY"},
-	{{A_RingDrain},              "A_RINGDRAIN"},
-	{{A_SplitShot},              "A_SPLITSHOT"},
-	{{A_MissileSplit},           "A_MISSILESPLIT"},
-	{{A_MultiShot},              "A_MULTISHOT"},
-	{{A_InstaLoop},              "A_INSTALOOP"},
-	{{A_Custom3DRotate},         "A_CUSTOM3DROTATE"},
-	{{A_SearchForPlayers},       "A_SEARCHFORPLAYERS"},
-	{{A_CheckRandom},            "A_CHECKRANDOM"},
-	{{A_CheckTargetRings},       "A_CHECKTARGETRINGS"},
-	{{A_CheckRings},             "A_CHECKRINGS"},
-	{{A_CheckTotalRings},        "A_CHECKTOTALRINGS"},
-	{{A_CheckHealth},            "A_CHECKHEALTH"},
-	{{A_CheckRange},             "A_CHECKRANGE"},
-	{{A_CheckHeight},            "A_CHECKHEIGHT"},
-	{{A_CheckTrueRange},         "A_CHECKTRUERANGE"},
-	{{A_CheckThingCount},        "A_CHECKTHINGCOUNT"},
-	{{A_CheckAmbush},            "A_CHECKAMBUSH"},
-	{{A_CheckCustomValue},       "A_CHECKCUSTOMVALUE"},
-	{{A_CheckCusValMemo},        "A_CHECKCUSVALMEMO"},
-	{{A_SetCustomValue},         "A_SETCUSTOMVALUE"},
-	{{A_UseCusValMemo},          "A_USECUSVALMEMO"},
-	{{A_RelayCustomValue},       "A_RELAYCUSTOMVALUE"},
-	{{A_CusValAction},           "A_CUSVALACTION"},
-	{{A_ForceStop},              "A_FORCESTOP"},
-	{{A_ForceWin},               "A_FORCEWIN"},
-	{{A_SpikeRetract},           "A_SPIKERETRACT"},
-	{{A_InfoState},              "A_INFOSTATE"},
-	{{A_Repeat},                 "A_REPEAT"},
-	{{A_SetScale},               "A_SETSCALE"},
-	{{A_RemoteDamage},           "A_REMOTEDAMAGE"},
-	{{A_HomingChase},            "A_HOMINGCHASE"},
-	{{A_TrapShot},               "A_TRAPSHOT"},
-	{{A_VileTarget},             "A_VILETARGET"},
-	{{A_VileAttack},             "A_VILEATTACK"},
-	{{A_VileFire},               "A_VILEFIRE"},
-	{{A_BrakChase},              "A_BRAKCHASE"},
-	{{A_BrakFireShot},           "A_BRAKFIRESHOT"},
-	{{A_BrakLobShot},            "A_BRAKLOBSHOT"},
-	{{A_NapalmScatter},          "A_NAPALMSCATTER"},
-	{{A_SpawnFreshCopy},         "A_SPAWNFRESHCOPY"},
-	{{A_FlickySpawn},            "A_FLICKYSPAWN"},
-	{{A_FlickyCenter},           "A_FLICKYCENTER"},
-	{{A_FlickyAim},              "A_FLICKYAIM"},
-	{{A_FlickyFly},              "A_FLICKYFLY"},
-	{{A_FlickySoar},             "A_FLICKYSOAR"},
-	{{A_FlickyCoast},            "A_FLICKYCOAST"},
-	{{A_FlickyHop},              "A_FLICKYHOP"},
-	{{A_FlickyFlounder},         "A_FLICKYFLOUNDER"},
-	{{A_FlickyCheck},            "A_FLICKYCHECK"},
-	{{A_FlickyHeightCheck},      "A_FLICKYHEIGHTCHECK"},
-	{{A_FlickyFlutter},          "A_FLICKYFLUTTER"},
-	{{A_FlameParticle},          "A_FLAMEPARTICLE"},
-	{{A_FadeOverlay},            "A_FADEOVERLAY"},
-	{{A_Boss5Jump},              "A_BOSS5JUMP"},
-	{{A_LightBeamReset},         "A_LIGHTBEAMRESET"},
-	{{A_MineExplode},            "A_MINEEXPLODE"},
-	{{A_MineRange},              "A_MINERANGE"},
-	{{A_ConnectToGround},        "A_CONNECTTOGROUND"},
-	{{A_SpawnParticleRelative},  "A_SPAWNPARTICLERELATIVE"},
-	{{A_MultiShotDist},          "A_MULTISHOTDIST"},
-	{{A_WhoCaresIfYourSonIsABee},"A_WHOCARESIFYOURSONISABEE"},
-	{{A_ParentTriesToSleep},     "A_PARENTTRIESTOSLEEP"},
-	{{A_CryingToMomma},          "A_CRYINGTOMOMMA"},
-	{{A_CheckFlags2},            "A_CHECKFLAGS2"},
-	{{A_Boss5FindWaypoint},      "A_BOSS5FINDWAYPOINT"},
-	{{A_DoNPCSkid},              "A_DONPCSKID"},
-	{{A_DoNPCPain},              "A_DONPCPAIN"},
-	{{A_PrepareRepeat},          "A_PREPAREREPEAT"},
-	{{A_Boss5ExtraRepeat},       "A_BOSS5EXTRAREPEAT"},
-	{{A_Boss5Calm},              "A_BOSS5CALM"},
-	{{A_Boss5CheckOnGround},     "A_BOSS5CHECKONGROUND"},
-	{{A_Boss5CheckFalling},      "A_BOSS5CHECKFALLING"},
-	{{A_Boss5PinchShot},         "A_BOSS5PINCHSHOT"},
-	{{A_Boss5MakeItRain},        "A_BOSS5MAKEITRAIN"},
-	{{A_Boss5MakeJunk},          "A_BOSS5MAKEJUNK"},
-	{{A_LookForBetter},          "A_LOOKFORBETTER"},
-	{{A_Boss5BombExplode},       "A_BOSS5BOMBEXPLODE"},
-	{{A_DustDevilThink},         "A_DUSTDEVILTHINK"},
-	{{A_TNTExplode},             "A_TNTEXPLODE"},
-	{{A_DebrisRandom},           "A_DEBRISRANDOM"},
-	{{A_TrainCameo},             "A_TRAINCAMEO"},
-	{{A_TrainCameo2},            "A_TRAINCAMEO2"},
-	{{A_CanarivoreGas},          "A_CANARIVOREGAS"},
-	{{A_KillSegments},           "A_KILLSEGMENTS"},
-	{{A_SnapperSpawn},           "A_SNAPPERSPAWN"},
-	{{A_SnapperThinker},         "A_SNAPPERTHINKER"},
-	{{A_SaloonDoorSpawn},        "A_SALOONDOORSPAWN"},
-	{{A_MinecartSparkThink},     "A_MINECARTSPARKTHINK"},
-	{{A_ModuloToState},          "A_MODULOTOSTATE"},
-	{{A_LavafallRocks},          "A_LAVAFALLROCKS"},
-	{{A_LavafallLava},           "A_LAVAFALLLAVA"},
-	{{A_FallingLavaCheck},       "A_FALLINGLAVACHECK"},
-	{{A_FireShrink},             "A_FIRESHRINK"},
-	{{A_SpawnPterabytes},        "A_SPAWNPTERABYTES"},
-	{{A_PterabyteHover},         "A_PTERABYTEHOVER"},
-	{{A_RolloutSpawn},           "A_ROLLOUTSPAWN"},
-	{{A_RolloutRock},            "A_ROLLOUTROCK"},
-	{{A_DragonbomberSpawn},      "A_DRAGONBOMBERSPAWN"},
-	{{A_DragonWing},             "A_DRAGONWING"},
-	{{A_DragonSegment},          "A_DRAGONSEGMENT"},
-	{{A_ChangeHeight},           "A_CHANGEHEIGHT"},
-	{{NULL},                     "NONE"},
+	{A_Explode,                "A_EXPLODE"},
+	{A_Pain,                   "A_PAIN"},
+	{A_Fall,                   "A_FALL"},
+	{A_MonitorPop,             "A_MONITORPOP"},
+	{A_GoldMonitorPop,         "A_GOLDMONITORPOP"},
+	{A_GoldMonitorRestore,     "A_GOLDMONITORRESTORE"},
+	{A_GoldMonitorSparkle,     "A_GOLDMONITORSPARKLE"},
+	{A_Look,                   "A_LOOK"},
+	{A_Chase,                  "A_CHASE"},
+	{A_FaceStabChase,          "A_FACESTABCHASE"},
+	{A_FaceStabRev,            "A_FACESTABREV"},
+	{A_FaceStabHurl,           "A_FACESTABHURL"},
+	{A_FaceStabMiss,           "A_FACESTABMISS"},
+	{A_StatueBurst,            "A_STATUEBURST"},
+	{A_FaceTarget,             "A_FACETARGET"},
+	{A_FaceTracer,             "A_FACETRACER"},
+	{A_Scream,                 "A_SCREAM"},
+	{A_BossDeath,              "A_BOSSDEATH"},
+	{A_SetShadowScale,         "A_SETSHADOWSCALE"},
+	{A_ShadowScream,           "A_SHADOWSCREAM"},
+	{A_CustomPower,            "A_CUSTOMPOWER"},
+	{A_GiveWeapon,             "A_GIVEWEAPON"},
+	{A_RingBox,                "A_RINGBOX"},
+	{A_Invincibility,          "A_INVINCIBILITY"},
+	{A_SuperSneakers,          "A_SUPERSNEAKERS"},
+	{A_BunnyHop,               "A_BUNNYHOP"},
+	{A_BubbleSpawn,            "A_BUBBLESPAWN"},
+	{A_FanBubbleSpawn,         "A_FANBUBBLESPAWN"},
+	{A_BubbleRise,             "A_BUBBLERISE"},
+	{A_BubbleCheck,            "A_BUBBLECHECK"},
+	{A_AwardScore,             "A_AWARDSCORE"},
+	{A_ExtraLife,              "A_EXTRALIFE"},
+	{A_GiveShield,             "A_GIVESHIELD"},
+	{A_GravityBox,             "A_GRAVITYBOX"},
+	{A_ScoreRise,              "A_SCORERISE"},
+	{A_AttractChase,           "A_ATTRACTCHASE"},
+	{A_DropMine,               "A_DROPMINE"},
+	{A_FishJump,               "A_FISHJUMP"},
+	{A_ThrownRing,             "A_THROWNRING"},
+	{A_SetSolidSteam,          "A_SETSOLIDSTEAM"},
+	{A_UnsetSolidSteam,        "A_UNSETSOLIDSTEAM"},
+	{A_SignSpin,               "A_SIGNSPIN"},
+	{A_SignPlayer,             "A_SIGNPLAYER"},
+	{A_OverlayThink,           "A_OVERLAYTHINK"},
+	{A_JetChase,               "A_JETCHASE"},
+	{A_JetbThink,              "A_JETBTHINK"},
+	{A_JetgThink,              "A_JETGTHINK"},
+	{A_JetgShoot,              "A_JETGSHOOT"},
+	{A_ShootBullet,            "A_SHOOTBULLET"},
+	{A_MinusDigging,           "A_MINUSDIGGING"},
+	{A_MinusPopup,             "A_MINUSPOPUP"},
+	{A_MinusCheck,             "A_MINUSCHECK"},
+	{A_ChickenCheck,           "A_CHICKENCHECK"},
+	{A_MouseThink,             "A_MOUSETHINK"},
+	{A_DetonChase,             "A_DETONCHASE"},
+	{A_CapeChase,              "A_CAPECHASE"},
+	{A_RotateSpikeBall,        "A_ROTATESPIKEBALL"},
+	{A_SlingAppear,            "A_SLINGAPPEAR"},
+	{A_UnidusBall,             "A_UNIDUSBALL"},
+	{A_RockSpawn,              "A_ROCKSPAWN"},
+	{A_SetFuse,                "A_SETFUSE"},
+	{A_CrawlaCommanderThink,   "A_CRAWLACOMMANDERTHINK"},
+	{A_SmokeTrailer,           "A_SMOKETRAILER"},
+	{A_RingExplode,            "A_RINGEXPLODE"},
+	{A_OldRingExplode,         "A_OLDRINGEXPLODE"},
+	{A_MixUp,                  "A_MIXUP"},
+	{A_RecyclePowers,          "A_RECYCLEPOWERS"},
+	{A_Boss1Chase,             "A_BOSS1CHASE"},
+	{A_FocusTarget,            "A_FOCUSTARGET"},
+	{A_Boss2Chase,             "A_BOSS2CHASE"},
+	{A_Boss2Pogo,              "A_BOSS2POGO"},
+	{A_BossZoom,               "A_BOSSZOOM"},
+	{A_BossScream,             "A_BOSSSCREAM"},
+	{A_Boss2TakeDamage,        "A_BOSS2TAKEDAMAGE"},
+	{A_Boss7Chase,             "A_BOSS7CHASE"},
+	{A_GoopSplat,              "A_GOOPSPLAT"},
+	{A_Boss2PogoSFX,           "A_BOSS2POGOSFX"},
+	{A_Boss2PogoTarget,        "A_BOSS2POGOTARGET"},
+	{A_BossJetFume,            "A_BOSSJETFUME"},
+	{A_EggmanBox,              "A_EGGMANBOX"},
+	{A_TurretFire,             "A_TURRETFIRE"},
+	{A_SuperTurretFire,        "A_SUPERTURRETFIRE"},
+	{A_TurretStop,             "A_TURRETSTOP"},
+	{A_JetJawRoam,             "A_JETJAWROAM"},
+	{A_JetJawChomp,            "A_JETJAWCHOMP"},
+	{A_PointyThink,            "A_POINTYTHINK"},
+	{A_CheckBuddy,             "A_CHECKBUDDY"},
+	{A_HoodFire,               "A_HOODFIRE"},
+	{A_HoodThink,              "A_HOODTHINK"},
+	{A_HoodFall,               "A_HOODFALL"},
+	{A_ArrowBonks,             "A_ARROWBONKS"},
+	{A_SnailerThink,           "A_SNAILERTHINK"},
+	{A_SharpChase,             "A_SHARPCHASE"},
+	{A_SharpSpin,              "A_SHARPSPIN"},
+	{A_SharpDecel,             "A_SHARPDECEL"},
+	{A_CrushstaceanWalk,       "A_CRUSHSTACEANWALK"},
+	{A_CrushstaceanPunch,      "A_CRUSHSTACEANPUNCH"},
+	{A_CrushclawAim,           "A_CRUSHCLAWAIM"},
+	{A_CrushclawLaunch,        "A_CRUSHCLAWLAUNCH"},
+	{A_VultureVtol,            "A_VULTUREVTOL"},
+	{A_VultureCheck,           "A_VULTURECHECK"},
+	{A_VultureHover,           "A_VULTUREHOVER"},
+	{A_VultureBlast,           "A_VULTUREBLAST"},
+	{A_VultureFly,             "A_VULTUREFLY"},
+	{A_SkimChase,              "A_SKIMCHASE"},
+	{A_1upThinker,             "A_1UPTHINKER"},
+	{A_SkullAttack,            "A_SKULLATTACK"},
+	{A_LobShot,                "A_LOBSHOT"},
+	{A_FireShot,               "A_FIRESHOT"},
+	{A_SuperFireShot,          "A_SUPERFIRESHOT"},
+	{A_BossFireShot,           "A_BOSSFIRESHOT"},
+	{A_Boss7FireMissiles,      "A_BOSS7FIREMISSILES"},
+	{A_Boss1Laser,             "A_BOSS1LASER"},
+	{A_Boss4Reverse,           "A_BOSS4REVERSE"},
+	{A_Boss4SpeedUp,           "A_BOSS4SPEEDUP"},
+	{A_Boss4Raise,             "A_BOSS4RAISE"},
+	{A_SparkFollow,            "A_SPARKFOLLOW"},
+	{A_BuzzFly,                "A_BUZZFLY"},
+	{A_GuardChase,             "A_GUARDCHASE"},
+	{A_EggShield,              "A_EGGSHIELD"},
+	{A_SetReactionTime,        "A_SETREACTIONTIME"},
+	{A_Boss1Spikeballs,        "A_BOSS1SPIKEBALLS"},
+	{A_Boss3TakeDamage,        "A_BOSS3TAKEDAMAGE"},
+	{A_Boss3Path,              "A_BOSS3PATH"},
+	{A_Boss3ShockThink,        "A_BOSS3SHOCKTHINK"},
+	{A_Shockwave,              "A_SHOCKWAVE"},
+	{A_LinedefExecute,         "A_LINEDEFEXECUTE"},
+	{A_LinedefExecuteFromArg,  "A_LINEDEFEXECUTEFROMARG"},
+	{A_PlaySeeSound,           "A_PLAYSEESOUND"},
+	{A_PlayAttackSound,        "A_PLAYATTACKSOUND"},
+	{A_PlayActiveSound,        "A_PLAYACTIVESOUND"},
+	{A_SpawnObjectAbsolute,    "A_SPAWNOBJECTABSOLUTE"},
+	{A_SpawnObjectRelative,    "A_SPAWNOBJECTRELATIVE"},
+	{A_ChangeAngleRelative,    "A_CHANGEANGLERELATIVE"},
+	{A_ChangeAngleAbsolute,    "A_CHANGEANGLEABSOLUTE"},
+	{A_RollAngle,              "A_ROLLANGLE"},
+	{A_ChangeRollAngleRelative,"A_CHANGEROLLANGLERELATIVE"},
+	{A_ChangeRollAngleAbsolute,"A_CHANGEROLLANGLEABSOLUTE"},
+	{A_PlaySound,              "A_PLAYSOUND"},
+	{A_FindTarget,             "A_FINDTARGET"},
+	{A_FindTracer,             "A_FINDTRACER"},
+	{A_SetTics,                "A_SETTICS"},
+	{A_SetRandomTics,          "A_SETRANDOMTICS"},
+	{A_ChangeColorRelative,    "A_CHANGECOLORRELATIVE"},
+	{A_ChangeColorAbsolute,    "A_CHANGECOLORABSOLUTE"},
+	{A_Dye,                    "A_DYE"},
+	{A_SetTranslation,         "A_SETTRANSLATION"},
+	{A_MoveRelative,           "A_MOVERELATIVE"},
+	{A_MoveAbsolute,           "A_MOVEABSOLUTE"},
+	{A_Thrust,                 "A_THRUST"},
+	{A_ZThrust,                "A_ZTHRUST"},
+	{A_SetTargetsTarget,       "A_SETTARGETSTARGET"},
+	{A_SetObjectFlags,         "A_SETOBJECTFLAGS"},
+	{A_SetObjectFlags2,        "A_SETOBJECTFLAGS2"},
+	{A_RandomState,            "A_RANDOMSTATE"},
+	{A_RandomStateRange,       "A_RANDOMSTATERANGE"},
+	{A_StateRangeByAngle,      "A_STATERANGEBYANGLE"},
+	{A_StateRangeByParameter,  "A_STATERANGEBYPARAMETER"},
+	{A_DualAction,             "A_DUALACTION"},
+	{A_RemoteAction,           "A_REMOTEACTION"},
+	{A_ToggleFlameJet,         "A_TOGGLEFLAMEJET"},
+	{A_OrbitNights,            "A_ORBITNIGHTS"},
+	{A_GhostMe,                "A_GHOSTME"},
+	{A_SetObjectState,         "A_SETOBJECTSTATE"},
+	{A_SetObjectTypeState,     "A_SETOBJECTTYPESTATE"},
+	{A_KnockBack,              "A_KNOCKBACK"},
+	{A_PushAway,               "A_PUSHAWAY"},
+	{A_RingDrain,              "A_RINGDRAIN"},
+	{A_SplitShot,              "A_SPLITSHOT"},
+	{A_MissileSplit,           "A_MISSILESPLIT"},
+	{A_MultiShot,              "A_MULTISHOT"},
+	{A_InstaLoop,              "A_INSTALOOP"},
+	{A_Custom3DRotate,         "A_CUSTOM3DROTATE"},
+	{A_SearchForPlayers,       "A_SEARCHFORPLAYERS"},
+	{A_CheckRandom,            "A_CHECKRANDOM"},
+	{A_CheckTargetRings,       "A_CHECKTARGETRINGS"},
+	{A_CheckRings,             "A_CHECKRINGS"},
+	{A_CheckTotalRings,        "A_CHECKTOTALRINGS"},
+	{A_CheckHealth,            "A_CHECKHEALTH"},
+	{A_CheckRange,             "A_CHECKRANGE"},
+	{A_CheckHeight,            "A_CHECKHEIGHT"},
+	{A_CheckTrueRange,         "A_CHECKTRUERANGE"},
+	{A_CheckThingCount,        "A_CHECKTHINGCOUNT"},
+	{A_CheckAmbush,            "A_CHECKAMBUSH"},
+	{A_CheckCustomValue,       "A_CHECKCUSTOMVALUE"},
+	{A_CheckCusValMemo,        "A_CHECKCUSVALMEMO"},
+	{A_SetCustomValue,         "A_SETCUSTOMVALUE"},
+	{A_UseCusValMemo,          "A_USECUSVALMEMO"},
+	{A_RelayCustomValue,       "A_RELAYCUSTOMVALUE"},
+	{A_CusValAction,           "A_CUSVALACTION"},
+	{A_ForceStop,              "A_FORCESTOP"},
+	{A_ForceWin,               "A_FORCEWIN"},
+	{A_SpikeRetract,           "A_SPIKERETRACT"},
+	{A_InfoState,              "A_INFOSTATE"},
+	{A_Repeat,                 "A_REPEAT"},
+	{A_SetScale,               "A_SETSCALE"},
+	{A_RemoteDamage,           "A_REMOTEDAMAGE"},
+	{A_HomingChase,            "A_HOMINGCHASE"},
+	{A_TrapShot,               "A_TRAPSHOT"},
+	{A_VileTarget,             "A_VILETARGET"},
+	{A_VileAttack,             "A_VILEATTACK"},
+	{A_VileFire,               "A_VILEFIRE"},
+	{A_BrakChase,              "A_BRAKCHASE"},
+	{A_BrakFireShot,           "A_BRAKFIRESHOT"},
+	{A_BrakLobShot,            "A_BRAKLOBSHOT"},
+	{A_NapalmScatter,          "A_NAPALMSCATTER"},
+	{A_SpawnFreshCopy,         "A_SPAWNFRESHCOPY"},
+	{A_FlickySpawn,            "A_FLICKYSPAWN"},
+	{A_FlickyCenter,           "A_FLICKYCENTER"},
+	{A_FlickyAim,              "A_FLICKYAIM"},
+	{A_FlickyFly,              "A_FLICKYFLY"},
+	{A_FlickySoar,             "A_FLICKYSOAR"},
+	{A_FlickyCoast,            "A_FLICKYCOAST"},
+	{A_FlickyHop,              "A_FLICKYHOP"},
+	{A_FlickyFlounder,         "A_FLICKYFLOUNDER"},
+	{A_FlickyCheck,            "A_FLICKYCHECK"},
+	{A_FlickyHeightCheck,      "A_FLICKYHEIGHTCHECK"},
+	{A_FlickyFlutter,          "A_FLICKYFLUTTER"},
+	{A_FlameParticle,          "A_FLAMEPARTICLE"},
+	{A_FadeOverlay,            "A_FADEOVERLAY"},
+	{A_Boss5Jump,              "A_BOSS5JUMP"},
+	{A_LightBeamReset,         "A_LIGHTBEAMRESET"},
+	{A_MineExplode,            "A_MINEEXPLODE"},
+	{A_MineRange,              "A_MINERANGE"},
+	{A_ConnectToGround,        "A_CONNECTTOGROUND"},
+	{A_SpawnParticleRelative,  "A_SPAWNPARTICLERELATIVE"},
+	{A_MultiShotDist,          "A_MULTISHOTDIST"},
+	{A_WhoCaresIfYourSonIsABee,"A_WHOCARESIFYOURSONISABEE"},
+	{A_ParentTriesToSleep,     "A_PARENTTRIESTOSLEEP"},
+	{A_CryingToMomma,          "A_CRYINGTOMOMMA"},
+	{A_CheckFlags2,            "A_CHECKFLAGS2"},
+	{A_Boss5FindWaypoint,      "A_BOSS5FINDWAYPOINT"},
+	{A_DoNPCSkid,              "A_DONPCSKID"},
+	{A_DoNPCPain,              "A_DONPCPAIN"},
+	{A_PrepareRepeat,          "A_PREPAREREPEAT"},
+	{A_Boss5ExtraRepeat,       "A_BOSS5EXTRAREPEAT"},
+	{A_Boss5Calm,              "A_BOSS5CALM"},
+	{A_Boss5CheckOnGround,     "A_BOSS5CHECKONGROUND"},
+	{A_Boss5CheckFalling,      "A_BOSS5CHECKFALLING"},
+	{A_Boss5PinchShot,         "A_BOSS5PINCHSHOT"},
+	{A_Boss5MakeItRain,        "A_BOSS5MAKEITRAIN"},
+	{A_Boss5MakeJunk,          "A_BOSS5MAKEJUNK"},
+	{A_LookForBetter,          "A_LOOKFORBETTER"},
+	{A_Boss5BombExplode,       "A_BOSS5BOMBEXPLODE"},
+	{A_DustDevilThink,         "A_DUSTDEVILTHINK"},
+	{A_TNTExplode,             "A_TNTEXPLODE"},
+	{A_DebrisRandom,           "A_DEBRISRANDOM"},
+	{A_TrainCameo,             "A_TRAINCAMEO"},
+	{A_TrainCameo2,            "A_TRAINCAMEO2"},
+	{A_CanarivoreGas,          "A_CANARIVOREGAS"},
+	{A_KillSegments,           "A_KILLSEGMENTS"},
+	{A_SnapperSpawn,           "A_SNAPPERSPAWN"},
+	{A_SnapperThinker,         "A_SNAPPERTHINKER"},
+	{A_SaloonDoorSpawn,        "A_SALOONDOORSPAWN"},
+	{A_MinecartSparkThink,     "A_MINECARTSPARKTHINK"},
+	{A_ModuloToState,          "A_MODULOTOSTATE"},
+	{A_LavafallRocks,          "A_LAVAFALLROCKS"},
+	{A_LavafallLava,           "A_LAVAFALLLAVA"},
+	{A_FallingLavaCheck,       "A_FALLINGLAVACHECK"},
+	{A_FireShrink,             "A_FIRESHRINK"},
+	{A_SpawnPterabytes,        "A_SPAWNPTERABYTES"},
+	{A_PterabyteHover,         "A_PTERABYTEHOVER"},
+	{A_RolloutSpawn,           "A_ROLLOUTSPAWN"},
+	{A_RolloutRock,            "A_ROLLOUTROCK"},
+	{A_DragonbomberSpawn,      "A_DRAGONBOMBERSPAWN"},
+	{A_DragonWing,             "A_DRAGONWING"},
+	{A_DragonSegment,          "A_DRAGONSEGMENT"},
+	{A_ChangeHeight,           "A_CHANGEHEIGHT"},
+	{NULL,                     "NONE"},
 
 	// This NULL entry must be the last in the list
-	{{NULL},                   NULL},
+	{NULL,                     NULL},
 };
 
 ////////////////////////////////////////////////////////////////////////////////
diff --git a/src/deh_tables.h b/src/deh_tables.h
index 94af2fa52e..6ff9573014 100644
--- a/src/deh_tables.h
+++ b/src/deh_tables.h
@@ -14,7 +14,7 @@
 #define __DEH_TABLES_H__
 
 #include "doomdef.h" // Constants
-#include "d_think.h" // actionf_t
+#include "d_think.h" // actionf_p1
 #include "info.h" // Mobj, state, sprite, etc constants
 #include "lua_script.h"
 
@@ -44,7 +44,7 @@ struct flickytypes_s {
   */
 typedef struct
 {
-	actionf_t action; ///< Function pointer corresponding to the actual action.
+	actionf_p1 action; ///< Function pointer corresponding to the actual action.
 	const char *name; ///< Name of the action in ALL CAPS.
 } actionpointer_t;
 
